# Overview

GPT 3 is basically doing completion

# Input

Mahatma Gandhi was one of

# Output 

`Mahatma Gandhi was one of` the most influential figures in the history of India. He was a lawyer, philosopher, political leader, and civil rights activist who was instrumental in India's struggle for independence. He was an advocate of non-violence, and his philosophy of satyagraha, or peaceful resistance, was successful in achieving India's independence from Britain. He was also known for his famous slogan of "Ahimsa" or non-violence. Gandhi was a major proponent of civil rights and equality, and his life and work are still remembered and celebrated in India and around the world.

# Training

## High level training parameter

1. A large body of text:

Mahatma Gandhi was one of the most influential figures in the history of India. He was a lawyer, philosopher, political leader, and civil rights activist who was instrumental in India's struggle for independence. He was an advocate of non-violence, and his philosophy of satyagraha, or peaceful resistance, was successful in achieving India's independence from Britain. He was also known for his famous slogan of "Ahimsa" or non-violence. Gandhi was a major proponent of civil rights and equality, and his life and work are still remembered and celebrated in India and around the world.

## Training process for this body of text

Loop where the repeating step is:

- Ip: Mahatma

- Output: Model trained using transformer techinque is expected to figure out what is the word (token) that comes after Mahatma.

- Supervisation: If model says Gandhi, it was correct, if it says something else it was wrong. 

- Backprop: Based whether it was correct or wrong the weights are adjusted.

- Ip = current ip + the next word (the one the model was supposed to predict)

This loop is run till the training prose is fully processed.

No of token in the prose is like 100, it would take 100 steps.

## Notes

Right now none of us know what the algo for updating the weights.

Refer [Andrej Karpathy's tutorial](https://www.youtube.com/watch?v=kCc8FmEb1nY)

## Inference -- how it is used to do generation

- Input text: `Mahatma Gandhi was one of the`
- Process: Similar to training it would find the token immediatly after input prompt, then it would use the new sentence with the prompt + generated token as input for next generation.
- Add to it token like BEGIN, END, etc.

## High level take away

- All it does is try to predict next word.
- This might seem trivial, or even dumb:
> - It has experimentally proven to be very capable of learning deep patterns in the training corpus or even the language itself -- if you scale out the process (in terms of number of learning param & maybe the size of corpus)
> - By that I don't just mean, what would be the most appropriate next word in a statistical sense
> - You have think of this process -- training process as an unsupervised learning program that figures out patterns it is not explicitly being asked to learn (like telling the nueral network 'hai this is cat, that is not a cat')
> - You have think of the unsupervised learning process as something that finds patterns in a data set that nobody even knew to look for in the first place.
- An anecdote based on a paper I read - it is titled something like 'a hard lesson..' - don't put in your learnings - just scale out - don't put in any of your knowledge

- This kind of model -- we will call them 'models generated by transformer learning process' 'foundational LLMs', 'pure completion LLMs', 'non-conversational LLMs'

# GPT-3.5

GPT-3.5 or chat GPT is basically taking GPT-3 and fine turing it to be convo capable.

## Question

- Deepak: How do you do that?
- Karthik: There is a little bit of black boxing for this. This is not a unsupervised process. There is supervisation. The learning process is called 'Reinforcement Learning with Human Feedback' [RIHL]. It is very costly, Open AI is the first group who accomplished this goal (RIHL is a method of accomplishing the goal of taking GPT-3 to GPT-3.5 (conversational)). Their technique is RIHL and is a human supervision involved training process. Details -- none of us know -- black box. It is estimated to have taken large call centre worth of people lots of man hours. On top of that very expensive compute runs -- estimated million and millions of dollars. This technique is called Instruct-GPT (name of the paper)
- Karthik: Stanford people came up with something called Self-Instruct, which basically outsources the job of generating the same supervisation prompts (that humans were used in the case of chat GPT) to chat GPT itself. Basically it is like using a compiler to compile a compiler. Key point: Somebody made a gpt-3.5 capable model (called Alpaca) using RTX 4090 for an estimate 300-700$.